Package com.verisign.epp.codec.maintenance.v1_0

## Class EPPMaintenanceListItem

- java.lang.Object
- - com.verisign.epp.codec.maintenance.v1_0.EPPMaintenanceListItem

- All Implemented Interfaces:
    `EPPCodecComponent`, `java.io.Serializable`, `java.lang.Cloneable`

      public class EPPMaintenanceListItem
      extends java.lang.Object
      implements EPPCodecComponent

  Represents a maintenance list item that includes the following child elements:
  - <maint:id> element that is the maintenance identifier.
  - <maint:start> element that is the maintenance start date and time.
  - <maint:end> element that is the maintenance end date and time.
  - <maint:crDate> element that represents the created date and time for the maintenance.
  - An OPTIONAL <maint:upDate> element that represents the updated date and time for the maintenance.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `ELM_LOCALNAME` | XML local name for `EPPMaintenanceItem`.
    `static java.lang.String` | `ELM_NAME` | XML root tag for `EPPMaintenanceItem`.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `EPPMaintenanceListItem()` | Default constructor for `EPPMaintenanceItem`.
    `EPPMaintenanceListItem​(EPPMaintenanceId aMaintenanceId, java.util.Date aStartDate, java.util.Date aEndDate, java.util.Date aCreatedDate)` | Constructor for `EPPMaintenanceItem` with all of the required attributes as parameters.
    `EPPMaintenanceListItem​(EPPMaintenanceId aMaintenanceId, java.util.Date aStartDate, java.util.Date aEndDate, java.util.Date aCreatedDate, java.util.Date aLastUpdatedDate)` | Constructor for `EPPMaintenanceItem` with all of the attributes as parameters.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.Object` | `clone()` | Clone `EPPMaintenanceItem`.
    `void` | `decode​(org.w3c.dom.Element aElement)` | Decode the `EPPMaintenanceItem` attributes from the aElement DOM Element tree.
    `org.w3c.dom.Element` | `encode​(org.w3c.dom.Document aDocument)` | Encode a DOM Element tree from the attributes of the `EPPMaintenanceItem` instance.
    `boolean` | `equals​(java.lang.Object aObject)` | implements a deep `EPPMaintenanceItem` compare.
    `java.util.Date` | `getCreatedDate()` | Gets the maintenance created date.
    `java.util.Date` | `getEndDate()` | Gets the optional maintenance end date and time.
    `java.util.Date` | `getLastUpdatedDate()` | Gets the optional maintenance last updated date.
    `EPPMaintenanceId` | `getMaintenanceId()` | Gets the maintenance identifier.
    `java.lang.String` | `getNamespace()` | Returns the XML namespace associated with the `EPPCodecComponent`.
    `java.util.Date` | `getStartDate()` | Gets the optional maintenance start date and time.
    `boolean` | `hasEndDate()` | Is the end date defined?
    `boolean` | `hasLastUpdatedDate()` | Is the last updated date defined?
    `boolean` | `hasStartdDate()` | Is the start date defined?
    `void` | `setCreatedDate​(java.util.Date aCreatedDate)` | Sets the maintenance created date.
    `void` | `setEndDate​(java.util.Date aEndDate)` | Sets the optional maintenance end date and time.
    `void` | `setLastUpdatedDate​(java.util.Date aLastUpdatedDate)` | Sets the maintenance last updated date.
    `void` | `setMaintenanceId​(EPPMaintenanceId aMaintenanceId)` | Sets the maintenance identifier.
    `void` | `setStartDate​(java.util.Date aStartDate)` | Sets the optional maintenance start date and time.
    `java.lang.String` | `toString()` | Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### ELM_LOCALNAME

          public static final java.lang.String ELM_LOCALNAME

      XML local name for `EPPMaintenanceItem`.
      See Also:
        Constant Field Values

    - #### ELM_NAME

          public static final java.lang.String ELM_NAME

      XML root tag for `EPPMaintenanceItem`.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### EPPMaintenanceListItem

          public EPPMaintenanceListItem()

      Default constructor for `EPPMaintenanceItem`. All the the attributes default to `null`. Must call required setter methods before invoking `encode(Document)`, which include:
      - maintenance identifier - `setMaintenanceId(EPPMaintenanceId)`
      - maintenance created date - `setCreatedDate(Date)`

    - #### EPPMaintenanceListItem

          public EPPMaintenanceListItem​(EPPMaintenanceId aMaintenanceId,
                                        java.util.Date aStartDate,
                                        java.util.Date aEndDate,
                                        java.util.Date aCreatedDate)

      Constructor for `EPPMaintenanceItem` with all of the required attributes as parameters.
      Parameters:
        `aMaintenanceId` - Maintenance identifier
        `aStartDate` - Maintenance start date and time
        `aEndDate` - Maintenance end date and time
        `aCreatedDate` - Maintenance created date

    - #### EPPMaintenanceListItem

          public EPPMaintenanceListItem​(EPPMaintenanceId aMaintenanceId,
                                        java.util.Date aStartDate,
                                        java.util.Date aEndDate,
                                        java.util.Date aCreatedDate,
                                        java.util.Date aLastUpdatedDate)

      Constructor for `EPPMaintenanceItem` with all of the attributes as parameters.
      Parameters:
        `aMaintenanceId` - Maintenance identifier
        `aStartDate` - Maintenance start date. Set to `null` if undefined.
        `aEndDate` - Maintenance end date. Set to `null` if undefined.
        `aCreatedDate` - Maintenance created date
        `aLastUpdatedDate` - Maintenance last updated date. Set to `null` if undefined.

  - ### Method Detail

    - #### getMaintenanceId

          public EPPMaintenanceId getMaintenanceId()

      Gets the maintenance identifier.
      Returns:
        The maintenance identifier if defined; `null` otherwise.

    - #### setMaintenanceId

          public void setMaintenanceId​(EPPMaintenanceId aMaintenanceId)

      Sets the maintenance identifier.
      Parameters:
        `aMaintenanceId` - The maintenance identifier.

    - #### hasStartdDate

          public boolean hasStartdDate()

      Is the start date defined?
      Returns:
        `true` if the start date is defined; `false` otherwise.

    - #### getStartDate

          public java.util.Date getStartDate()

      Gets the optional maintenance start date and time.
      Returns:
        start date and time if defined; `null` otherwise.

    - #### setStartDate

          public void setStartDate​(java.util.Date aStartDate)

      Sets the optional maintenance start date and time.
      Parameters:
        `aStartDate` - Maintenance start date and time. Set to `null` if undefined.

    - #### hasEndDate

          public boolean hasEndDate()

      Is the end date defined?
      Returns:
        `true` if the end date is defined; `false` otherwise.

    - #### getEndDate

          public java.util.Date getEndDate()

      Gets the optional maintenance end date and time.
      Returns:
        end date and time if defined; `null` otherwise.

    - #### setEndDate

          public void setEndDate​(java.util.Date aEndDate)

      Sets the optional maintenance end date and time.
      Parameters:
        `aEndDate` - Maintenance end date and time. Set to `null` if undefined.

    - #### getCreatedDate

          public java.util.Date getCreatedDate()

      Gets the maintenance created date.
      Returns:
        Maintenance created date if defined; `null` otherwise.

    - #### setCreatedDate

          public void setCreatedDate​(java.util.Date aCreatedDate)

      Sets the maintenance created date.
      Parameters:
        `aCreatedDate` - Maintenance created date

    - #### hasLastUpdatedDate

          public boolean hasLastUpdatedDate()

      Is the last updated date defined?
      Returns:
        `true` if the last updated date is defined; `false` otherwise.

    - #### getLastUpdatedDate

          public java.util.Date getLastUpdatedDate()

      Gets the optional maintenance last updated date.
      Returns:
        Maintenance last updated date if defined; `null` otherwise.

    - #### setLastUpdatedDate

          public void setLastUpdatedDate​(java.util.Date aLastUpdatedDate)

      Sets the maintenance last updated date.
      Parameters:
        `aLastUpdatedDate` - Maintenance last updated date

    - #### encode

          public org.w3c.dom.Element encode​(org.w3c.dom.Document aDocument)
                                     throws EPPEncodeException

      Encode a DOM Element tree from the attributes of the `EPPMaintenanceItem` instance.
      Specified by:
        `encode` in interface `EPPCodecComponent`
      Parameters:
        `aDocument` - DOM Document that is being built. Used as an Element factory.
      Returns:
        Root DOM Element representing the `EPPMaintenanceItem` instance.
      Throws:
        `EPPEncodeException` - Unable to encode `EPPMaintenanceItem` instance.

    - #### decode

          public void decode​(org.w3c.dom.Element aElement)
                      throws EPPDecodeException

      Decode the `EPPMaintenanceItem` attributes from the aElement DOM Element tree.
      Specified by:
        `decode` in interface `EPPCodecComponent`
      Parameters:
        `aElement` - Root DOM Element to decode `EPPMaintenanceItem` from.
      Throws:
        `EPPDecodeException` - Unable to decode aElement.

    - #### equals

          public boolean equals​(java.lang.Object aObject)

      implements a deep `EPPMaintenanceItem` compare.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `aObject` - `EPPMaintenanceItem` instance to compare with
      Returns:
        `true` of `aObject` is equal to instance; `false` otherwise.

    - #### clone

          public java.lang.Object clone()
                                 throws java.lang.CloneNotSupportedException

      Clone `EPPMaintenanceItem`.
      Specified by:
        `clone` in interface `EPPCodecComponent`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        clone of `EPPMaintenanceItem`
      Throws:
        `java.lang.CloneNotSupportedException` - standard Object.clone exception

    - #### toString

          public java.lang.String toString()

      Implementation of `Object.toString`, which will result in an indented XML `String` representation of the concrete `EPPCodecComponent`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        Indented XML `String` if successful; `ERROR` otherwise.

    - #### getNamespace

          public java.lang.String getNamespace()

      Returns the XML namespace associated with the `EPPCodecComponent`.
      Specified by:
        `getNamespace` in interface `EPPCodecComponent`
      Returns:
        XML namespace for the `EPPCodecComponent`.